Prime Path POJ - 3126

Prime Path POJ - 3126

题目描述
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

大致题意
给你两个四位的素数,从前面一个变成后面一个,每次变换时只能改变一个位置上的数,而且要求变换后的数也是素数,问是否能从第一个素数变到第二个,如果能则输出所需最少的变换次数,否则输出Impossible

思路
bfs,每次改变个位,十位,百位,千位上的数,然后判断是否出现过,是不是素数(也可以预先打个四位数的素数表),注意千位上的数的范围1~9,其余的是0~9。

代码如下(借用某同学(自称小仙女)的代码)

#include <iostream>
#include <string.h>
#include <queue>
using namespace std;

struct node{
    int num;
    int step;
}st,et;
bool vis[10000];
int x, y;
queue<node> Q;

bool prime(int tt){
    for(int i = 2; i*i<=tt; i++){//注意判断素数时的取值范围,某同学(自称小仙女)这里错了,少了个=号,wa了半天)
        if(tt % i == 0){
            return false;
        }
    }
    return true;
}

int change(int i, node now){
    int temp = now.num;
    int tt;
    if(i == 0){
        for(int p = 1; p <= 9; p++){
            tt = p*1000 + temp%1000;
            if(prime(tt) && !vis[tt] && tt != temp){
                vis[tt] = true;
                node next;
                next.num = tt;
                next.step = now.step+1;
                Q.push(next);
            }
        }
    }
    else{
        for(int p = 0; p <= 9; p++)
        {
            if(i == 1){
                tt = temp/1000*1000 + p*100 + temp%100;
                if(prime(tt) && !vis[tt] && tt != temp){
                    vis[tt] = true;
                    node next;
                    next.num = tt;
                    next.step = now.step+1;
                    Q.push(next);
                }
            }
            else if(i == 2){
                tt = temp/100*100 + p*10 + temp%10;
                if(prime(tt) && !vis[tt] && tt != temp){
                    vis[tt] = true;
                    node next;
                    next.num = tt;
                    next.step = now.step+1;
                    Q.push(next);
                }
            }
            else if(i == 3){
                tt = temp/10*10 + p;
                if(prime(tt) && !vis[tt] && tt != temp){
                    vis[tt] = true;
                    node next;
                    next.num = tt;
                    next.step = now.step+1;
                    Q.push(next);
                }
            }
        }
    }
}


void bfs(){
    while(!Q.empty()){
        Q.pop();
    }

    Q.push(st);
    vis[x] = true;
    while(!Q.empty()){
        node temp = Q.front();
        Q.pop();
        if(temp.num == y){
            cout << temp.step<< endl;
            return;
        }
        for(int i = 0; i < 4; i++){
            change(i, temp);
        }
    }
   cout << "Impossible" << endl;
    return;
}

int main(){
    ios::sync_with_stdio(false);
    //freopen("ftest.txt", "r", stdin);

    int n;
    cin >> n;
    while(n--){
        cin >> x >> y;
        st.num = x;
        st.step = 0;
        et.num = y;
        et.step = 0;
         memset(vis, false, sizeof(vis));
        bfs();
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值